
#include <avr/io.h>
#include <avr/interrupt.h>
#include <util/delay.h>
#include <avr/pgmspace.h>
#include <stdio.h>
#include "lcd.h"


void setup(void){

	/* Setez pinul PB2 ca intrare. */

	DDRA &= ~(1 << PA0);
	DDRA &= ~(1 << PA1);
	DDRA &= ~(1 << PA2);
	DDRA &= ~(1 << PA3);
	DDRA &= ~(1 << PA4);

	/* Activez rezistenta de pull-up pentru pinul PB2. */
	PORTA |= (1 << PA0);
	PORTA |= (1 << PA1);
	PORTA |= (1 << PA2);
	PORTA |= (1 << PA3);
	PORTA |= (1 << PA4);

	/* Setez pinul PC0 ca iesire. */
	DDRB |= (1 << PB0);
	DDRB |= (1 << PB1);
	DDRB |= (1 << PB2);
	DDRB |= (1 << PB3);
	DDRB |= (1 << PB4);
	DDRD |= (1 << PD7);

	/* Sting LED-ul. */

	PORTB &= ~(1 << PB0);
	PORTB &= ~(1 << PB1);
	PORTB &= ~(1 << PB2);
	PORTB &= ~(1 << PB3);
	PORTB &= ~(1 << PB4);

}


void run(void) {


int x, s = 0, sc = 0, best = 0;;
char buff[20];


	 while (1) {

		x = rand() & 0xff;
		x |= (rand() & 0xff) << 8;
		x |= (rand() & 0xff) << 16;
		x |= (rand() & 0xff) << 24;


		if (x > 0 && x < 650){
		 	PORTB |= (1 << PB0);

			if(best > 20 || sc > 20)
				goto ALVL3;

			if(best > 10 || sc > 10)
				goto ALVL2;

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

ALVL2:
			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);
ALVL3:
			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);


			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA0)) == 1)
				s = 1;


			PORTB &= ~(1 << PB0);
			if(s != 1){
				PORTD |= (1 << PD7);
				if(sc > best){
					best = sc;
				}
				sc = 0;
				lcd_clear();
				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
				lcd_goto_xy(1,2);
				printf("Best: ");
				itoa(best,buff,10);
				printf("%s",buff);
				if(best < 10){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(best > 10 && best < 20){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(best > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}
			} else{
				sc++;
				if(sc < 10 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(sc > 10 && sc < 20 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(sc > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}

				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
			}

			_delay_ms(1000);
			PORTD &= ~(1 << PD7);
			s = 0;
		}

		if(x > 650 && x < 1300) {
			PORTB |= (1 << PB1);

			if(best > 20 || sc > 20)
				goto BLVL3;

			if(best > 10 || sc > 10)
				goto BLVL2;


			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

BLVL2:
			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);
BLVL3:
			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);


			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA1)) != 0)
				s = 1;

			PORTB &= ~(1 << PB1);
			if(s != 1){
				PORTD |= (1 << PD7);
				if(sc > best){
					best = sc;
				}
				sc = 0;
				lcd_clear();
				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
				lcd_goto_xy(1,2);
				printf("Best: ");
				itoa(best,buff,10);
				printf("%s",buff);
				if(best < 10){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(best > 10 && best < 20){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(best > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}
			} else{
				sc++;
				if(sc < 10 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(sc > 10 && sc < 20 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(sc > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}

				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
			}
			_delay_ms(1000);
			PORTD &= ~(1 << PD7);
			s = 0;
		}

		if(x > 1300 && x < 1900) {
			PORTB |= (1 << PB2);

			if(best > 20 || sc > 20)
				goto CLVL3;

			if(best > 10 || sc > 10)
				goto CLVL2;


			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);
			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);

CLVL2:
			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);
CLVL3:
			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);


			if((PINA & (1 << PA2)) != 0)
				s = 1;
			_delay_ms(1000);

			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA2)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA2)) != 0)
				s = 1;

			PORTB &= ~(1 << PB2);
			if(s != 1){
				PORTD |= (1 << PD7);
				if(sc > best){
					best = sc;
				}
				sc = 0;
				lcd_clear();
				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
				lcd_goto_xy(1,2);
				printf("Best: ");
				itoa(best,buff,10);
				printf("%s",buff);
				if(best < 10){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(best > 10 && best < 20){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(best > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}
			} else{
				sc++;
				if(sc < 10 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(sc > 10 && sc < 20 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(sc > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}

				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
			}
			_delay_ms(1000);
			PORTD &= ~(1 << PD7);
			s = 0;
		}

		if(x > 1900 && x < 2600) {
			PORTB |= (1 << PB3);

			if(best > 20 || sc > 20)
				goto DLVL3;

			if(best > 10 || sc > 10)
				goto DLVL2;

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

DLVL2:
			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);
DLVL3:
			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);


			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA3)) != 0)
				s = 1;

			PORTB &= ~(1 << PB3);
			if(s != 1){
				PORTD |= (1 << PD7);
				if(sc > best){
					best = sc;
				}
				sc = 0;
				lcd_clear();
				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
				lcd_goto_xy(1,2);
				printf("Best: ");
				itoa(best,buff,10);
				printf("%s",buff);
				if(best < 10){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(best > 10 && best < 20){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(best > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}
			} else{
				sc++;
				if(sc < 10 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(sc > 10 && sc < 20 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(sc > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}

				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
			}
			_delay_ms(1000);
			PORTD &= ~(1 << PD7);
			s = 0;
		}

		if(x > 2600 && x < 3200) {
			PORTB |= (1 << PB4);


			if(best > 20 || sc > 20)
				goto ELVL3;

			if(best > 10 || sc > 10)
				goto ELVL2;

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

ELVL2:
			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);
ELVL3:
			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);


			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			_delay_ms(1000);

			if((PINA & (1 << PA4)) != 0)
				s = 1;

			PORTB &= ~(1 << PB4);
			if(s != 1){
				PORTD |= (1 << PD7);
				if(sc > best){
					best = sc;
				}
				sc = 0;
				lcd_clear();
				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
				lcd_goto_xy(1,2);
				printf("Best: ");
				itoa(best,buff,10);
				printf("%s",buff);
				if(best < 10){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(best > 10 && best < 20){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(best > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}
			} else{
				sc++;
				if(sc < 10 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 1");
				}
				if(sc > 10 && sc < 20 && best < sc){
					lcd_goto_xy(1,3);
					printf("Level: 2");
				}
				if(sc > 20){
					lcd_goto_xy(1,3);
					printf("Level: 3");
				}


				lcd_goto_xy(1,1);
				printf("Score: ");
				itoa(sc,buff,10);
				printf("%s",buff);
			}
			_delay_ms(1000);
			PORTD &= ~(1 << PD7);
			s = 0;
		}


	 }
}

void game(){

	lcd_init();
	lcd_contrast(0x40);
	lcd_clear();
	lcd_goto_xy(6,2);
	printf("Press");
	lcd_goto_xy(3,3);
	printf("any button");
	lcd_goto_xy(4,4);
	printf("to start");

	while(1)
	if((PINA & (1 << PA0)) != 0 || (PINA & (1 << PA1)) != 0 || (PINA & (1 << PA2)) != 0 || (PINA & (1 << PA3)) != 0 || (PINA & (1 << PA4)) != 0){
		lcd_clear();
		lcd_goto_xy_exact(0,0);
		lcd_goto_xy(1,1);
		printf(" Reaction test");
		lcd_goto_xy(1,3);
		lcd_str("Game starts in");
		lcd_goto_xy(8,5);
		lcd_str("5");
		_delay_ms(30000);
		lcd_goto_xy(8,5);
		lcd_str("4");
		_delay_ms(30000);
		lcd_goto_xy(8,5);
		lcd_str("3");
		_delay_ms(30000);
		lcd_goto_xy(8,5);
		lcd_str("2");
		_delay_ms(30000);
		lcd_goto_xy(8,5);
		lcd_str("1");
		_delay_ms(30000);
		lcd_clear();
		run();
	}
}


/* main -- Te fun starts here */
int main(void)
{
	setup();
	game();

}
